== Changelog ==

= 6.4.2 - May 9th, 2018 =
* Added a new API function to create notes on a subscriber's profile
* Added no default options for radio buttons and dropdowns (both merge fields and interest groups).
* Added a basic unsubscribe shortcode and all of the JS/CSS/API functions that support this.
* Added a filter, `yikes-mailchimp-wooco-integration-checkbox-checkout-fields`, that allows you to move the placement of the WooCommerce checkout integration checkbox to the bottom of the form.
* Fixed an issue where hidden interest groups required a default value
* Fixed an issue with the Easy Forms Gutenberg block

= 6.4.1 - May 2nd, 2018 =
- Fixing a syntax error in Easy Forms v6.4.0 related to PHP Versions < 5.4

= 6.4.0 - May 1st, 2018 =
* All calls to the MailChimp v2 API have been removed or updated to the v3 API where possible.
* The Account page has been removed because it was relying on V2 API endpoints. Some account data from this page has been moved to the Manage Lists page.
* The ChimpChatter dashboard widget has been removed.
* The List Activity dashboard widget has a new filter, `yikes-mailchimp-dashboard-widgets-enabled`, that controls whether the widget is loaded or not.
* The welcome screen you see on plugin activation/updates has been removed.
* The error log now lives in a new place outside the plugin: wp-content/uploads/yikes-log/yikes-easy-mailchimp-error-log.php.
* The changelog is now in its own file, changelog.txt, and has been removed from the readme. 
* The inline form styles should now handle a theme's default padding/margin better. There are also a bunch of new filters for customizing a form's inline styles. 
* Setting up a scheduled form should be a much smoother process now.
* Some inline JavaScript for processing a form's shortcode has been moved into the form-submission-helpers.js file.
* You can now customize the message displayed to the user after an update profile email is requested. You'll see a new custom message section has been added to the form builder.
* Our checkbox integrations (e.g. Contact Form 7, WooCommerce) now allow you to choose multiple lists (and corresponding interest groups) for your subscribers to sign up to. 
* Added some initial support for Easy Forms in Gutenberg. Feel free to download the Gutenberg plugin and test out the Easy Forms Block!

= 6.3.30 - February 15th, 2018 =
* Added a new filter: `yikes_mailchimp_widget_shortcode_attributes`. You can use this filter to customize the shortcode arguments for your Easy Forms widget. For example, you can remove the recaptcha from a widget.
* Added a new filter: `yikes-easy-mailchimp-email-address-field`. You can use this filter to customize the email merge field. For example, you can rename the field to something other than "Email Address."
* Fixed the way the loading SVGs were added in JavaScript. You can now use the existing filters to safely remove them.
* Removed the dependency from the Public CSS file.

= 6.3.29 - November 8th, 2017 =
* Refactored the way the support form works and integrates with add-ons
* Refactored the way the transients are deleted when the API key is cleared - adding a new API key should now properly clear all cached data
* Added a filter - `yikes-mailchimp-page-data` - that can be used to prevent page data from being POSTed with a subscription request

= 6.3.28 - October 21st, 2017 =
* Fixing bug with 6.3.27's single optin resubscribe

= 6.3.27 - October 20th, 2017 =
* Replaced the current loading gifs with SVGs
* Added support for address field placeholder values. You can filter these values with the filter `yikes-mailchimp-address-{$addr_type}-placeholder`.
* Added support for single opt-in unsubscribed users to re-subscribe. Shout out to @jasonhildebrand for adding this functionality. 
* Fixed an issue with interest groups. This should fix the "Invalid Interest Group: 0" error some users saw. Another really big shoutout to @jasonhildebrand for fixing this directly.
* Fixed up some PHP warnings - thanks to @szepeviktor on GitHub for reporting these.

= 6.3.26 - October 4th, 2017 =
* Added two new filters: `yikes-mailchimp-{$merge_tag}-default-value` and `yikes-mailchimp-wooco-integration-checkbox-placement`.

= 6.3.25 - September 11th, 2017 =
* Fixing some HTML validation/markup errors related to labels. Thanks to @upekshapriya for bringing these to our attention.

= 6.3.24 - August 28th, 2017 =
* If a subscriber has unsubscribed, the signup form will re-send them a confirmation email (double opt-in only)
* If a subscriber received the double confirmation email but never subscribed (pending status), the signup form will re-send them a confirmation email (double opt-in only)

= 6.3.23 - August 14th, 2017 =
* Removed an additional `esc_url` call on the redirect URL. Redirect URLs should now be able to accept characters like ampersands without encoding them.
* Fixed the way the `yikes-mailchimp-general-error-response` filter works. You can now use the original response as the first argument in the function. This should allow you to change a MailChimp response w/ str parsing.
* Some minor code cleanup

= 6.3.22 - June 23rd, 2017 =
* Fixed an issue with comment integration subscriptions - comments will now be spam checked correctly

= 6.3.21 - June 22nd, 2017 =
* Cleaned up some HTML on the form
* Fixed an issue with comment integration subscriptions - the commenter's name will now populate the First Name field in your MailChimp list.

= 6.3.20 - May 31st, 2017 =
* Added a filter - `yikes-mailchimp-integration-is-user-subscribed` - for the integration checkbox. You can override whether the checkbox will display for already subscribed users (by default, the checkbox will not display).
* Updated the way we're logging errors for the homepage dashboard widgets - an error should no longer break your dashboard!
* Added some default excluded post types for our post query on the form builder (CPTS are forum, topic, and reply). This should help people who use bbPress and are experiencing timeout issues. (These can be filtered with the `yikes-mailchimp-excluded-redirect-post-types`).

= 6.3.19 - May 16th, 2017 =
* Fixed a bug where hidden form fields were being counted as visible.
* Added a new filter - yikes-mailchimp-save-form-filter - that allows you to filter all of a form's data before it gets saved.
* Replaced the current datepicker with the standard jQuery core datepicker. Added styles and custom code to support this.
* Added a new filter - yikes-mailchimp-datepicker-options - that allows you to filter the datepicker options.

= 6.3.18 - May 3rd, 2017 =
* Added a filter, `yikes-mailchimp-checkbox-integration-body`, for the checkbox integrations. You can now filter the entire request body before it's sent to MailChimp.
* Fixed up the code that was requiring address 2. By default, the address 2 field will never be required (can be changed with filters `yikes-mailchimp-address-2-required` and `yikes-mailchimp-ignore-required-array-field`).

= 6.3.17 - May 1st, 2017 =
* Added a quick fix for the Addon Settings list 

= 6.3.16 - April 26th, 2017 =
* Quick fix to 6.3.15 - forgot to add a couple of files that handle the "Description Above Field" when a form field/interest group is initially added to the form.

= 6.3.15 - April 26th, 2017 =
* Google Analytics Event Tracking is here! We've added an action - `yikes-mailchimp-google-analytics` - where you can add Google Analytics JavaScript. Check out our knowledge base article (https://yikesplugins.com/support/knowledge-base/add-google-analytics-event-tracking/) for more instructions.
* The form builder field instructions are now hidden when there are no fields added to the form.
* Added the Clear API Cache button to the form builder - you can find the button in the Associated List Settings box.
* Added a new option to the fields in the form builder: the ability to place the description above the field. This also comes with some minor style changes and a couple new filters: `'yikes-mailchimp-{$interest_group_id}-description-html'` to filter the interest group's description HTML, and `'yikes-mailchimp-{$merge_tag}-description-html'` to filter a form/merge field's description HTML.
* Added HTML so that labels will work properly in the form builder. You can now select input fields by clicking on the field's label.

= 6.3.14 - April 21st, 2017 =
* Updating the WooCommerce Checkout integration checkbox with a new class and a filter for the classes (yikes-mailchimp-wooco-integration-checkbox-classes). The checkbox should now align correctly. 
* Added a new setting to the General Setting page that controls using the nonce validation. The nonce has caused numerous people issues, and the filter is difficult for some people. This new setting will turn off the nonce validation for all forms on the website. The previously added filter, yikes-mailchimp-use-nonce-verification, can still turn off nonce validation on a per-form basis.

= 6.3.13 - April 17th, 2017 = 
* Two new filters: `yikes-mailchimp-wp-comment-integration-placement` and `yikes-mailchimp-use-nonce-verification`.
* `yikes-mailchimp-use-nonce-verification` - Control whether we verify the nonce on form submissions. Default: `true` (by default, we check the nonce). @params: $use_nonce, $form_id
* `yikes-mailchimp-wp-comment-integration-placement` - Control the placement of the subscription checkbox for the WP Comment Form integration. Default: `comment_form_field_comment` (after the comment textarea box) - @params: $comment_form_field. This filter allows you to choose which WP Comment Form filter to use, and for the full list of WP Comment Form filters, check the documentation: https://codex.wordpress.org/Function_Reference/comment_form.

= 6.3.12 - April 6th, 2017 = 
* Security vulnerability patched - Discovered with DefenseCode ThunderScan Source Code Security Analyzer by Neven Biruski

= 6.3.11 - March 23rd, 2017 =
* Optimized our query that fetches all posts/pages/CPTs - we now fetch only the IDs - this should prevent issues such as memory overflow or timeout

= 6.3.10 - March 21st, 2017 =
* Added a filter to customize the options in the states' dropdown. You can now add your own states/provinces, or remove the default ones. Use `yikes-mailchimp-state-province-list`
* Added a filter to customize the behavior of the zip code field. There are now around 20 different countries that the zip code field will be displayed for. Use the filter `yikes-mailchimp-countries-with-zip` to add/remove.
* Fixed an error handling bug that occurred when interest groups were empty for certain integrations

= 6.3.9.1 - March 14th, 2017 =
* Added a new option for AJAX submissions with redirect set: open in new window/tab. (Note: some browsers may detect the redirect as a popup and block it by default)
* Refactored the way the redirect logic worked

= 6.3.9 - March 10th, 2017 =
* The dismiss button for the "Please Review Us" box now redirects you to your current page instead of the admin home page.

= 6.3.8 - March 3rd, 2017 =
* Fixed an issue with label classes and refactored the code - there are now spaces in between the classes

= 6.3.7 - March 3rd, 2017 =
* Fixed an issue with the JavaScript helper file that was updated in 6.3.5 - the update profile link should now work as expected (shout out to @manouallouon on GitHub for pointing this out)

= 6.3.6 - February 27th, 2017 =
* Removing the following post types from our dropdown of potential redirect pages: `custom_css`, `customize_changeset`, and WooCommerce's `shop_order` and `shop_order_refund`.
* Adding a filter (`yikes-mailchimp-excluded-redirect-post-types`) to allow users to define which CPTs will be excluded from the list of potential redirect pages. See the "Other Notes" section for the default list of excluded post types.

= 6.3.5 - February 13th, 2017 =
* Added Canadian provinces to the state dropdown list. If you choose "Canada" as your country, you will see only the provinces. If you choose U.S. you will see only the states. For all other countries, the dropdown will fade out.
* Added the filter: `yikes-mailchimp-default-zip-code` for defaulting the zip code
* Added the variable $form_id to the `yikes-mailchimp-default-country-value`, `yikes-mailchimp-address-{$type}-label`, and `yikes-mailchimp-zip-pattern` filters
* Fixed an issue with pagination when viewing a list's subscribers. By default, each page jumps ahead 20 subscribers. This can be changed with the filter `yikes_admin_list_subscriber_limit`.
* Fixed an issue where using double/single quotes in field names could break the field name.

= 6.3.4 - February 2nd, 2017 = 
* CSS update to fix an issue with interest groups displaying in the form builder caused by 6.3.3

= 6.3.3 - February 1st, 2017 = 
* Security vulnerability patched - props to @nathan-hermit for bringing this to our attention
* New feature: the ability to edit field labels
* Generated new .pot file

= 6.3.2 - January 25th, 2017 = 
* Custom message visibility is now dictated by your opt-in settings
* Fixed an issue with the PHP `array_keys` function that breaks PHP versions < 5.4
* Hidden interest groups now work properly and are defined as checkboxes for consistency with MailChimp
* Some minor copy changes and a new .pot file

= 6.3.1 - January 18th, 2017 = 
* Generated new .pot file for proper i18n/l10n

= 6.3.0 - January 17th, 2017 = 
* Version 6.3.0's biggest change is migrating the plugin to use MailChimp's v3 API.
* Created API classes to interact with the MailChimp API
* Converted all supported v2 endpoints to the corresponding v3 endpoint
* Refactored all v2 endpoints that are unsupported in v3 to use the new API classes
* Added filters to customize API requests

* Version 6.3.0 includes a suite of custom message updates:
* Removed the "invalid email" custom message (v3 no longer supports error codes to detect things like an invalid email error)
* Updated the custom messages descriptions text
* Updated the success message - it is now specifically for successful double opt-in subscriptions
* Added two new custom success messages: "Success: Single opt-in" for successful single opt-in subscriptions, and "Success: Re-subscriber" for successful re-subscriptions
* Added two new custom messages for customizing the "update your profile link" email: "Email Subject" to customize the subject of the email, and "Email body" to customize the body of the email
* Added/Updated filters for each custom message type. See the `Filters` section for more details.

* Version 6.3.0 includes a suite of bug fixes, enhancements, and changes:
* Added server-side validation to check for required form fields and required interest groups; this supports browsers like Safari that do not support the HTML 5 `required` attribute, or situations where the JavaScript validation fails
* Added the HTML 5 required attribute to radio button and dropdown formatted interest groups
* Wrapped the subscription form submit button's text in a span to better support adding custom HTML to the submit button text
* Changed the types of values that are wiped out after submission to better support subscribing multiple times without refreshing the page
* Added a nonce to the subscription form submission
* Multiple interest groups can now be highlighted and added to the form at the same time (instead of one at a time)
* Fixed the way default values work for interest groups and checkbox/dropdown/radio form fields
* Changed the way the datepicker displays birthdays when the date format is DD/MM
* Added error handling and a default error message for fatal server errors ('Error collecting the API response')
* Allowing + signs for phone fields using MailChimp's international phone format (supports country codes)
* Added transients throughout the application for common requests (e.g. API requests and internal form data requests)
* The "Send Welcome Email" option is no longer supported by MailChimp and has been removed
* The second address line (addr2) is never required by default (this can be changed using a filter - see `yikes-mailchimp-address-2-required`).

* Version 6.3.0 includes a lot of new filters, some renamed filters, some new parameters added, and some filters removed. For a complete list of available filters, please see the newly updated filters section. Here are some of the highlights:
* Renamed filters `yikes-mailchimp-before-submission` and `yikes-mailchimp-before-submission-{$form_id}` to `yikes-mailchimp-filter-before-submission` and `yikes-mailchimp-filter-before-submission-{$form_id}`. This prevents conflicts between the actions of the same name.
* Renamed filter `yikes-mailchimp-user-already-subscribed-error` to `yikes-mailchimp-user-already-subscribed-text`
* Added filters `yikes-mailchimp-filter-groups-before-submission` and `yikes-mailchimp-filter-groups-before-submission-{$form_id}` to filter the interest groups before they're submitted
* Removed filters `yikes-mailchimp-user-subscribe-api-request`, `yikes-mailchimp-checkbox-integration-subscribe-api-request`
* Removed filter `yikes-mailchimp-interest-group-required-top-error` - replaced by `yikes-mailchimp-required-interest-group-missing` - this handles all types of interest group fields, not just checkboxes
* Removed filter `yikes-mailchimp-interest-group-checkbox-error` - missing fields are now highlighted

= 6.2.4 - December 6th, 2016 =
* Fixed the way birthday field data was being handled / stored
* Added version number to main AJAX JavaScript file - Thanks goes to Viktor Szépe for committing this change
* Tested with WordPress version 4.7 (and updated the corresponding 'Tested up to' tag)
* Added minor error handling and logic to the forms page

= 6.2.3 - November 1st, 2016 =
* Changed the way HTML field data is retrieved for compatibility with the options DB table and the Incentives Add-on
* Fixed the path to the Knowledge Base on the welcome page
* Refactored and localized the tinyMCE JS file
* Fixed an i18n issue where an incorrect URL was being displayed in an error message
* Changed the way the address field is displayed when viewing a mailing list user's info

= 6.2.2 - October 25th, 2016 =
* Minor security patch - Thanks goes to the Tristan Madani for locating and disclosing the issues below.
* Fixed a bug where request variable "section" was not sanitize before execution and rendering
* Fixed a bug where global constant "YIKES_MC_API_KEY" was not sanitize before execution and rendering
* Fixed a bug where WP option "yikes-mc-api-key" was not sanitize before validating and saving

= 6.2.1 - October 19th, 2016 =
* Fixed a bug where the title and description will not display using the shortcode.
* Fixed a bug where the `recaptcha` shortcode parameter doesn't work properly.

= 6.2.0 - October 17th, 2016 =
* Fixed a bug where the default for a radio button would not show up if the first item was selected ([#587](https://github.com/yikesinc/yikes-inc-easy-mailchimp-extender/issues/587))
* Fixed a bug where the form settings would not import properly ([#572](https://github.com/yikesinc/yikes-inc-easy-mailchimp-extender/issues/572))
* Fixed a bug in our Visual Composer extension ([#514](https://github.com/yikesinc/yikes-inc-easy-mailchimp-extender/issues/514))
* Fixed a bug where Interest Groups that are in radio format could not be changed when saving ([#584](https://github.com/yikesinc/yikes-inc-easy-mailchimp-extender/issues/584))
* Fixed a bug where the Phone Format field would continually append # signs ([#562](https://github.com/yikesinc/yikes-inc-easy-mailchimp-extender/issues/562))
* Fixed a compatibilty issue where our localized script variables were using common names ([#575](https://github.com/yikesinc/yikes-inc-easy-mailchimp-extender/issues/575))
* Updated the storage of form data to utilize the Options API instead of a custom database table.
* Under-the-hood improvements and enhancements

As noted above, this release modifies this plugin to utilize the Options API instead of a custom database table. After upgrading, a routine will run that will grab all of your forms from the custom database table and convert them into a WordPress Option that the code will use from this point forward. At this point, we're choosing to keep the existing custom database table in place, so you can rest assured that all of your form data will be safe.

If for some reason you need to revert to using the custom database table, you can add a constant to your `wp-config.php` file:

`define( 'YIKES_EMCE_CUSTOM_DB', true );`

If you find that you *need* to do this, please contact us to let us know what you're seeing. In a future release, we will remove the custom database table entirely.

= 6.1.3 - July 26th, 2016 =
* Minor security patch - Thanks goes to the Wordfence Research Team for locating and disclosing the issue.
* Cleared API/Account transient data when API key has changed.
* Refactored our shortcode function to abort early, when no fields are present (inline or not).
* Added `labels-hidden` class to the submit button `<span></span>` element so we can better style inline forms when <strong>all</strong> labels are hidden.

= 6.1.2 - July 21st, 2016 =
* Fixed incorrect date format on date picker for birthday fields (Front end).
* Ensure that hidden fields don't become visible when forms are submitted (.fadeTo() bug)
* Built in support for defining a constant for your API keys in wp-config.php (`YIKES_MC_API_KEY` see FAQ)

= 6.1.1 - July 20th, 2016 =
* Added helper classes to the address fields to allow for easier targeting (Supports zip lookup extension).

= 6.1 - July 11th, 2016 =
* Sanitized section request on the options page properly.
* Fixed the apostraphes converted to tildes.
* Added the missing space in the form field classes when labels were hidden.
* Added preloaders to the submit button and the form overlay. Lowered opacity during AJAX processing.
* Fixed the 'Duplicate' form function.
* Repaired phone number validation on the phone form fields.
* Properly hide descriptions when they are not set. (Markup should no longer be generated)
* Added a 'Clear API Cache' link below the associated list dropdown during form creation.
* Swapped out `get_currentuserinfo()` for the correct, newer, functions.
* Repaired undefined variable on the 'Birthday/Date' form fields, when no default was set.
* Users can now bulk add fields to forms, instead of having to do it one at a time.
* Removed any dependency to the RSS feeds served from https://www.yikesplugins.com, which could potentially cause issues if the servers are ever down.
* Refactored the database creation function, and swapped out the field types - to support older versions of PHP (<v5.3).
* Added new filter to allow users to alter who can view/access the admin dashboard widgets - `yikes-mailchimp-admin-widget-capability`
* Added a new filter (`yikes-mailchimp-user-already-subscribed-error`) allowing the 'already subscribed' error message to be filtered.
* Added a new template tag (`[email]`) which can be used in the already subscribed response, to display the user entered email back in the response.
* Added a new template tag (`[link][/link]`) which can be used to wrap text in the 'update profile' link, allowing users to create a custom response & link.

= 6.0.5.5 - April 5th, 2016 =
* Fixed incompatibility with the avada theme options page.
* Removed the admin dashboard widgets for non-admins. Note: To alter, use the `yikes-mailchimp-user-role-access` filter.

= 6.0.5.4 - March 30th, 2016 =
* Added `yikes-mailchimp-before-form-submission` hook, to perform actions before data gets sent to MailChimp.
* Setup unit tests, wrote a few basic tests to start.
* Added `no_priv` to the update profile email, so users who are not logged in do not hit an error.

= 6.0.5.3 - March 14th, 2016 =
* Removed rogue `return;` causing blank screen on certain pages.
* Wrapped transient in else statement to prevent wrong data from being stored when an error is hit.

= 6.0.5.2 - March 11th, 2016 =
* Added extra error check for empty forms.
* Fixed incorrect 'Invalid Email' response being displayed to the user. (Now more user friendly)
* Fixed some checkbox integrations not working properly.
* Enhanced error logging.

= 6.0.5.1 - March 7th, 2016 =
* Cleaned up an error getting by the check when no interest groups were enabled on a form.
* Ensured 'invalid email' error was being used where appropriate.

= 6.0.5 - March 5th, 2016 =
* Removed the old MailChimp PHP wrapper (increasing stability, and decreasing overall plugin size by 200+kb).
* All API requests are now handled via WP HTTP class (goodbye SSL cert errors)
* Added new `yikes-mailchimp-sslverify` filter to toggle true/false on API requests.
* Added a new 'View List' link below the associated lists on the form edit page.
* Updated all api requests throughout the plugin.
* Re-wrote both the ajax and non-ajax form submission files.
* Re-wrote form validation, error checks and success/error responses.
* More specific error messages now coming from MailChimp for a better debugging experience.
* Repaired broken strings, Optin/optin to Opt-in/opt-in, reCaptcha to reCAPTCHA.
* Fixed user data not properly displaying on the user cards page.

= 6.0.4.7 - March 4th, 2016 =
* Fix error being thrown when the user has not set their name on the profile page.
* Updated the API validation function to use WP HTTP class. (workaround for SSL cert error preventing API key validation)
* Add 'Custom URL' selection to page redirect drop down, allow users to hard code a custom URL to redirect users to (third party site etc.)

= 6.0.4.6 - March 2nd, 2016 =
* Repair 'update existing subscriber' parameter in the API request to respect the options set for the given form (AJAX and non-AJAX forms).

= 6.0.4.5 - March 1st, 2016 =
* Added `load_plugin_textdomain()` call to base class.
* Added missing string to translation.

= 6.0.4.4 - February 29th, 2016 =
* Fixed reCAPTCHA check being skipped when a non-ajax form is submitted.
* Fixed incorrect variable name in reCAPTCHA form submission (non-ajax).
* Re-worded the reCAPTCHA error message when left blank.
* Passed new reCAPTCHA error message through new filter (`yikes-mailchimp-recaptcha-required-error` - works for AJAX and standard forms).
* Added missing placeholder/default values to the date form fields.
* Fixed foreign characters causing issues on certain form fields (all languages should now work without issues).

= 6.0.4.3 - February 23rd, 2016 =
* Added new filter to alter the success message from the form (`yikes-mailchimp-success-response` - see readme.txt for help).
* Added new filter to alter the zip code regex pattern (`yikes-mailchimp-zip-pattern` - see readme.txt for help and default value).
* Added new filter to alter the default country selection in the dropdown. (`yikes-mailchimp-default-country-value` - Defaults to 'US'.)
* Altered zip/state fields, when the default value is set to something other than US via `yikes-mailchimp-default-country-value`.
* Removed `height: 100%` CSS declaration on form fields (causing minor issues on some themes).
* Tweaked front end .js.

= 6.0.4.2 - February 18th, 2016 =
* Add missing .js file to trigger the update existing subscriber detials email on non-ajax forms.
* Re-worded a few strings.

= 6.0.4.1 - February 17th, 2016 =
* Fixed foreign languages saving field labels with backslashes.
* Fixed foreign language dropdown not saving/displaying properly.
* Setup two-factor authentication when users go to update subscription details.
* Added new filters, `yikes-mailchimp-update-email-subject` and `yikes-mailchimp-update-email-content`.
* Removed languages directory, as everything is now handled within GlotPress.

= 6.0.4 - February 1st, 2016 =
* Added a conditional to upgrade the database if the user is not currently up to date.
* Some users report not being able to update form settings, due to database tables not being present.

= 6.0.3.9 - January 31st, 2016 =
* Refactored date form field submissions, to properly format international dates (dd/mm/yyyy).
* Re-worded sections.
* Added new screenshots.

= 6.0.3.8 - January 29th, 2016 =
* Added a new custom description parameter to the shortcode. eg: `[yikes-mailchimp custom_description="This is a custom description" description="1"]`
* Added all new settings on a per form level. New options now include - Form classes, Inline form, Submit button type, Submit button classes, schedule form by date/time, and require users to be logged in.
* Users can now specify if they want a form to display inline by using the `inline="1"` parameter in the shortcode. Example: `[yikes-mailchimp inline="1"]`. The shortcode parameter will take precedence over the form setting.
* Users can now set the submit button to image, and specify a custom image to use.
* Tweaked styles on the 'Account Activity/Chimp Chatter' page.
* Re-factored a few functions to be more performant.
* Added new, additional hooks for our add-ons to make use of. (`yikes-mailchimp-list-interest-groups-metabox`)
* Fixed the typo in our check box integration filter from `yikes-mailchimp-checkbox-integration-subscibe-api-request` to `yikes-mailchimp-checkbox-integration-subscribe-api-request`.
* Added missing `$charset_collate` variable when creating the database tables - which caused encoding issues with a few foreign characters.
* Localized all date pickers - for our international users.
* Added new sections to the welcome screen - 'Knowledge Base' and 'Add-Ons'.
* Fixed foreign language character encoding, and storing in database as question marks.
* Fixed date formats not storing properly when adding a date/birthday field to your form.
* Fixed the form editor being hidden on medium-width screens.

= 6.0.3.7 - December 28th, 2015 =
* Fixed certain [recaptcha parameters](https://yikesplugins.com/support/knowledge-base/how-do-i-customize-the-recaptcha-field/) not working properly

= 6.0.3.6 - December 28th, 2015 =
* Removed extra closing php tag after 'Interest Group' dropdown field

= 6.0.3.5 - December 20th, 2015 =
* Ensured the `$form_id` variable is set before including the form processing file for non-ajax forms.
* Updated `yikes_retrieve_form_settings()`, to ensure we have a `$form_id` and settings to return.

= 6.0.3.4 - December 18th, 2015 =
* Make bundled classes work when field labels are hidden.
* Way to reset submission counts for individual forms.
* URL fields now prepend http:// to prevent confusion with the end user.
* Added conditionals to hide state/zip input fields in the address section when the country != US.
* Multiple reCAPTCHAs on a single page should now work.
* Non-Ajax Forms set to redirect, throw errors
* Check form descriptions generating additional `<p>` tags.yikes-mailchimp-form-description is not wrapped around the description.
* Add helper function to retrieve form data by ID. (eg: `$form_data = yikes_get_form_data( 1 );` )

= 6.0.3.3 - November 12th, 2015 =
* Patched a minor security issue where post passwords were accessible prior to entering the password - (props @ldwd)

= 6.0.3.2 - November 9th, 2015 =
* International characters in custom messages causing some escaping issues for AJAX forms.
* Added Google reCAPTCHA override to the shortcode recaptcha="1"/recpatcha="0" to manually set it on a per form basis (still needs to be globally enabled on the settings page).
* Added additional reCAPTCHA parameters to the shortcode. (see <a href="https://yikesplugins.com/support/knowledge-base/how-do-i-customize-the-recaptcha-field/" target="_blank">https://yikesplugins.com/support/knowledge-base/how-do-i-customize-the-recaptcha-field/</a>).
* Re-coded the redirect function for non-ajax forms, so that it properly utilizes `wp_redirect()` instead of a .js injection after submission.
* Added new constant `YIKES_MAILCHIMP_NULL_DEBUG` to debug 'null' API response from MailChimp API (see <a href="https://yikesplugins.com/support/knowledge-base/i-received-the-following-error-we-received-an-unexpected-error-null/" target="_blank">https://yikesplugins.com/support/knowledge-base/i-received-the-following-error-we-received-an-unexpected-error-null/</a>).

= 6.0.3.1 - November 2nd, 2015 =
* Repair issue where multiple AJAX forms on same page was only submitting last displayed form.
* Parsed `[yikes-mailchimp-subscriber-count]`, to display the number of subscribers in the associated list on the manage forms page for form descriptions.
* When 'Hide Label' and 'Hide Field' are both checked, ensure that the associated form field is hidden.
* Confirmed error messages via the API are working as intended for both AJAX/standard opt-in forms.
* Fixed issue/spacing of the secondary 'Update Form' button on the edit forms page.

= 6.0.3 - October 29th, 2015 =
* Add filter to allow altering field descriptions. `yikes_mailchimp_frontend_content`
* Resolve error thrown when no default is set for checkbox inerest groups.
* Alter old knowledge base URLs to new KB URL.
* Confirm each form field type 'Hide Field' works as expected.
* Added a bit of spacing between checkbox/radio button default options.
* Added new class `yikes-mailchimp-form-class` to allow for additional classes to be added to the `<form>` element.
* Implemented a fix for required interest group checkbox type. (ajax = js validation/non-ajax = php).
* Appended form IDs to input field ID parameter. The new form IDs now prepended with yikes-mc-form-#- -- eg: Old: id="EMAIL", New: id="yikes-mc-form-1-EMAIL".
* Add a "Save Form" button to the left of the new "Clear Form Fields" on the Form builder. (better UX)
* Integrate with Visual Composer plugin.
* Ability to add a class to the form tag. Appropriate filter is `yikes-mailchimp-form-class` for `<form>` element, and `yikes-mailchimp-form-container-class` for parent `<section>` container.
* Fix Site Origin Page builder issues saving the widget form IDs.

= 6.0.3 - October 29th, 2015 =
* Fixed undefined variable warning for interest group labels
* Added new filter to allow alterations of each form field description

= 6.0.2.4 - October 17th, 2015 =
* Fixed error thrown for some users on edit forms page 'save'.
* Added new shortcode: `[yikes-mailchimp-subscriber-count list="#"]` to display the number of subscribers to a specified list (use: `[yikes-mailchimp-subscriber-count form="form_id"]` (preferred) or `[yikes-mailchimp-subscriber-count list="mc_list_id"]`)
* Added new filter to filter the submit button text (yikes-mailchimp-form-submit-button-text)
* Tweaked international phone number validation - now regex checks [0-9]{1,}
* Added two new classes to field labels - `.merge_tag-label` (eg: EMAIL-label) on all fields & `.yikes-mailchimp-field-required` on fields set to required.
* Added capability check to TinyMCE button in wp editor (defaults to manage_options).
* Tweaked 'show some love' container on the edit forms page.
* Ensured 'Clear Form Fields' button was hidden after all form fields were removed.
* Passed form descriptions through `the_content()` to allow for shortcodes to be processed.

= 6.0.2.3 - October 16th, 2015 =
* Fixed incorrect opt-in time being sent to MailChimp for new subscribers (fixed for checkbox integrations, ajax and non-ajax forms)
* Fixed 'Hide Label' displaying twice under interest groups
* Fixed error thrown for custom_fields for some users
* Fixed dropdown interest group data not being sent to MailChimp properly

= 6.0.2.2 - October 15th, 2015 =
* Added the ability to bulk remove form fields from the form builder
* Fixed hidden interest groups from not displaying the default value properly
* Added hidden interest groups to the field type switch
* Fixed interest group errors thrown for some users
* Added new option to replace/update interest groups

= 6.0.2/6.0.2.1 - October 12th, 2015 =
* Added ability to pre-select interest groups for each third party integration (bbpress, contact form 7, buddypress, edd, woocommerce, comment form, registration form).
* Removed "Check your email for the confirmation message." from the default success message if single opt-in is checked.
* Fixed Address field, zip not hiding properly.
* Tweaked class names, labels.
* Renamed clickable pre-defined tags to something more user friendly instead of tags (eg: 'Page Title' instead of {page_title}).
* Renamed the `field-third-left/right` class to `field-third` as it made more sense. Now elements floated left.
* Tweaked pre-defined class styles.
* Altered pre-defined class names for the address fields.
* Built in check for MailChimp class to prevent conflict with other plugins integrating MailChimp.
* Built in responsive styles for pre-defined form class styles (field-half-left/right & field-third).
* Tweak responsive styles on calendar date picker on mobile devices.
* Confirm each integration is working as intended.

= 6.0.1 - October 7th, 2015 =
* This release is a <strong>complete</strong> rewrite of the previous version. Before upgrading to the latest release, it is <em>highly recommended</em> that you take a backup of your database.
* Changed plugin name to Easy Forms for MailChimp to comply with new guidelines for [Plugins that Include Company and/or Product Names in the Plugin Name](https://make.wordpress.org/plugins/2015/10/05/guidelines-for-plugins-that-include-company-andor-product-names-in-the-plugin-name/)
* Enhancements:
* All forms have moved to their own table in the database, yikes_easy_mc_forms.
* Admin interface has been re-designed for a seamless integration into the WordPress dashboard.
* You can now create an unlimited number of forms, and assign them to any of your lists (even multiple forms to the same list).
* Now you can easily duplicate forms at the click of a button.
* We have built out an advanced debugging feature that will log errors as they occur, for easy debugging.
* You can now toggle on/off AJAX form submissions on a per form basis.
* Toggle on or off the MailChimp welcome email being sent.
* You can now quickly switch which list your forms assign subscribers to.
* We now support every type of field you can assign to a form, including interest groups.
* You can now set custom success and error messages, to set messages in your native language.
* Easily browse your lists and view individual subscribers. Manage your subscriptions directly within the plugin.
* We've completely re-designed the settings pages to allow for easier navigation.
* A whole number of additional settings have been enabled for different form input fields.
* Español translated started by @hiwhatsup
* Française translated by @mialevesque
* Português do Brasil translated by @enxaqueca
* reCAPTCHA now loads in the language of the site it's being displayed on.
* All translations functions have been implemented for worldwide i18n.
* We have built out an API and implemented a number of hooks and filters to enable developers to easily extend the plugin [see knowledge base](https://yikesplugins.com/support/knowledge-base/product/developer-documentation/?utm_source=wp_plugin_repo&utm_medium=link&utm_campaign=easy_forms_for_mailchimp)
* We have started building out a number of add ons to extend the base functionality of the plugin. [check them out](https://yikesplugins.com/plugins/?utm_source=wp_plugin_repo&utm_medium=link&utm_campaign=easy_forms_for_mailchimp)

= 5.4.3 - March 17th, 2015 =
* Fixed: Re-import form fields function not properly refreshing the page
* Fixed: Updating a list field no longer throws an empty error

= 5.4.2 - March 10th, 2015 =
* Fixed: custom class names on input fields merged together with other class names making them un-usable.

= 5.4.1 - March 3rd, 2015 =
* Fixed: tinyMCE error thrown when saving settings page, ultimately preventing the ability to store the API key.

= 5.4 - March 2nd, 2015 =
* Enhancement: Re-bundled unaltered MailChimp API wrapper class file, and added appropriate class check to prevent conflicts with other MailChimp plugins (Gravity Forms etc.)
* Enhancement: Removed the WYSIWYG editor from the options page. This caused issues for some users who were unable to validate the MailChimp API key.
* Enhancement: Added a new setting to toggle the sending of the MailChimp welcome email. Users can now disable the email all together, on a list by list basis. (checked = disabled)
* Enhancement: Prevented users from being able to update the 'EMAIL' merge variable. Added a notification with instruction on what filter to use.
* Enhancement: Replaced all instances of the old class name (wpyksMCMailChimp API) with the appropriate MailChimp class (Mailchimp)
* Enhancement: Stripped slashes and properly escaped interest group labels


= 5.3.3 - February 26th, 2015 =
* Enhancement: Added a new filter to alter field labels. Very helpful when you want to alter the default 'Email Address' field label to something else. (`yikes_mc_field_label`) (see 'filters' section in 'Other Notes')

= 5.3.2 - February 17th, 2015 =
* Fixed: Patched the error displayed below the opt-in forms when `display_yikes_mc_form_messages` is not defined.

= 5.3.1 - January 13th, 2014 =
* Enhancement: Added new filter to allow users to change which role has access to the administration pages ( `yks-mailchimp-user-role` ) ( check readme for example )

= 5.3 - January 11th, 2014 =
* Enhancement: Added ability to move the success + error messages above or below the form based on a defined constant ( `display_yikes_mc_form_messages` [options: before/after] )
* Enhancement: Added new settings and the ability to show/hide * = required field , from the top of the forms, via the settings page
* Enhancement: Fixed incorrect error 'click here to update your profile' shown on front end on all errors

= 5.2 - December 10th, 2014 =
* New Feature: Added ability to add, edit or delete form fields directly from the WordPress dashboard
* New Feature: Added ability to add, edit or delete interest groups directly from the WordPress dashboard
* New Feature: Add "Update" link to forms when a user has previously subscribed
* New Feature: Added 'default' option to text fields ( with custom pre-defined tags : {post_id} , {post_title} , {page_url} , {blog_name} , {user_logged_in} with the ability to define your own! )
* New Feature: Added the ability to adjust required state, visibility state, merge tag and more
* New Feature: Added the ability to toggle between ssl_verifypeer true/false
* New Feature: Added an error log to help users diagnose errors happening within the plugin (and updated advanced debugging) - found on the debug options of the settings page
* Enhancement: Remove JavaScript dependency to populate place holder values
* Enhancement: Replaced CAPTCHA with the all new reCAPTCHA API from Google
* Enhancement: Introduced all new filters ( check documentation for examples )
* Enhancement: Un-checking 'visibility' now hides the input field (instead of not generating it at all)
* Enhancement: Re-defined YKSEME_PATH for users who have the plugins folder outside of wp-content
* Enhancement: Added new classes to labels and input fields on the front end forms ( new classes yks-mc-label-field-label , yks-mc-form-row-field-label , yks-mc-input-field-row-field-label , yks-mc-input-field-label )
* Bug Fix: Re-sorting fields that had a stored custom class name didn't store properly
* Bug Fix: Wrapped bundled template text in filters
* Bug Fix: Repaired some broken filters (get_form_data_before_send)
* Bug Fix: Fixed labels on 'Manage List Forms' page and added field names to titles
* Bug Fix: Fixed path to check box images on 'Clean Blue' bundled templates
* Bug Fix: Fixed empty MailChimp API key from outputting any string (confused some users)
* Other: Split main class file into multiple included files (help organize the main class file (sub-files located in /lib/inc/)
* Other: Began to build up a [Wiki](https://github.com/yikesinc/yikes-inc-easy-mailchimp-extender/wiki) on Github , for plug in installation/usage instructions
* Other: Altered single/double opt-in strings inside shortcode_form.php ([reference thread](https://wordpress.org/support/topic/code-mangling-on-script-use-in-messageserror-handling))
* Other: Removed 'Interest Group Label' option, as users can now update the name from within the plugin

= 5.1.1 - November 5, 2014 =
Fix: repair 'Opt In' default list drop down on options page
Fix: repair errors being thrown when a commenter is added to a list

= 5.1.0.1 - November 4, 2014 =

Removed the update profile info link, some users brought up security concerns.
Fixed missing argument when using table display formatting.

= 5.1 - November 3, 2014 =

We have added brand new functionality, allowing users to easily customize forms on the fly, through a familiar UI as well as a templating framework to allow users to design and implement their own custom forms. A minor security bug was patched in this release as well. We fixed an issue with the MailChimp API key check running on each page load, and added a few new filters to allow users to alter text.

= 5.0.9 - October 3rd, 2014 =

**Fixes**

* Added autocomplete="false" to MailChimp API input field
* Added event listener to form submission (forms can now be placed in modals/slideout menus)

= 5.0.8 - September 23, 2014 =

**Fixes**

* Band-aid fix for the -1 response returned from ajax.php

= 5.0.7 - September 19, 2014 =

**Fixes**

* Security Vulnerability patched - props @g0blinResearch for privately disclosing the issue

= 5.0.6 - August 22, 2014 =

**Fixes**

* fix bug with nonce security check when using table 'Preferred Form Layout' setting

= 5.0.5 - August 21, 2014 =

**Fixes**

- added `stripslashes()` to the following settings fields :
	- Single Opt-in Confirmation Message
	- Double Opt-in Confirmation Message
	- Interest Group Label
	- Opt-in Checkbox Text

**Updates**

- Updated readme FAQ section

= 5.0.4 - August 6, 2014 =
* Update SSL conditional in main plugin file
* Added mcrypt module check, for API encryption
* Conditionally loaded scripts and styles in admin ( prevent conflicts )
* Included NONCE security checks on form submissions ( helps prevent CSRF and other attacks )
* Added proper update task function to add missing settings to the options page ( prevents undefined variables for new settings )
* Added missing styles to post page ( added missing icon to tinyMCE button )
* Added missing styles to widget page
* Adjusted Chimp Chatter activity time formatting to return correct time based on user time zone
* New Feature: Real time updates to Account Activity ( utilizing the heartbeat API )
* New Feature: Added account activity widget to dashboard ( with live updates using heartbeat API )
* Added screenshot of admin dashboard account activity widget

= 4.5 =
* Added reCAPTCHA support to prevent bots and spammers from submitting forms
* Split settings page into three separate sections
* Removed Jetpack sharing icons from appearing in the success messages (removed sharedaddy filter)
* Updated translation files with new strings
* Update existing screen shots and add new screen shot
* Update FAQ
* Added "loaded server modules" to the debug page, to better aid in support requests

= 3.0 =
* Update MailChimp API to v2.0
* Added API Key Validation Check

= 2.2.0 =
* Added support for multiples of the same list
* Bug fixes

= 2.1.0 =
* Changed name of plugin to Easy Forms
* Added support for multiples of the same list
* Bug fixes

= 2.0.0 =
* Supports custom merge vars now
* Allows import from MailChimp
* Allows Table or Div output

= 1.3.1 =
* Fixed form not submitting to MailChimp for anonymous users bug

= 1.3.0 =
* Custom merge vars allows more customized field configuration

= 1.2.0 =
* Removed required from First Name and Last Name fields
* Added update routines for future versions

= 1.1.0 =
* Changed the list logic and added a notice for the MERGE VAR naming schema

= 1.0.1 =
* Changed CSS paths from Absolute to Relative

= 1.0.0 =
* Initial Release


== Upgrade Notice ==

= 6.1.3 - July 26th, 2016 =

* Minor security patch - Thanks goes to the Wordfence Research Team for locating and disclosing the issue.
* Cleared API/Account transient data when API key has changed.
* Refactored our shortcode function to abort early, when no fields are present (inline or not).
* Added `labels-hidden` class to the submit button `<span></span>` element so we can better style inline forms when <strong>all</strong> labels are hidden.

= 6.1.2 - July 21st, 2016 =

* Fixed incorrect date format on date picker for birthday fields (Front end).
* Ensure that hidden fields don't become visible when forms are submitted (.fadeTo() bug)
* Built in support for defining a constant for your API keys in wp-config.php (`YIKES_MC_API_KEY` see FAQ)

= 6.1.1 - July 20th, 2016 =

* Added helper classes to the address fields to allow for easier targeting (Supports zip lookup extension).

= 6.1 - July 11th, 2016 =

* Sanitized section request on the options page properly.
* Fixed the apostraphes converted to tildes.
* Added the missing space in the form field classes when labels were hidden.
* Added preloaders to the submit button and the form overlay. Lowered opacity during AJAX processing.
* Fixed the 'Duplicate' form function.
* Repaired phone number validation on the phone form fields.
* Properly hide descriptions when they are not set. (Markup should no longer be generated)
* Added a 'Clear API Cache' link below the associated list dropdown during form creation.
* Swapped out `get_currentuserinfo()` for the correct, newer, functions.
* Repaired undefined variable on the 'Birthday/Date' form fields, when no default was set.
* Users can now bulk add fields to forms, instead of having to do it one at a time.
* Removed any dependency to the RSS feeds served from https://www.yikesplugins.com, which could potentially cause issues if the servers are ever down.
* Refactored the database creation function, and swapped out the field types - to support older versions of PHP (<v5.3).
* Added new filter to allow users to alter who can view/access the admin dashboard widgets - `yikes-mailchimp-admin-widget-capability`
* Added a new filter (`yikes-mailchimp-user-already-subscribed-error`) allowing the 'already subscribed' error message to be filtered.
* Added a new template tag (`[email]`) which can be used in the already subscribed response, to display the user entered email back in the response.
* Added a new template tag (`[link][/link]`) which can be used to wrap text in the 'update profile' link, allowing users to create a custom response & link.

= 6.0.5.5 - April 5th, 2016 =

* Fixed incompatibility with the avada theme options page.
* Removed the admin dashboard widgets for non-admins. Note: To alter, use the `yikes-mailchimp-user-role-access` filter.

= 6.0.5.4 - March 30th, 2016 =

* Added `yikes-mailchimp-before-form-submission` hook, to perform actions before data gets sent to MailChimp.
* Setup unit tests, wrote a few basic tests to start.
* Added `no_priv` to the update profile email, so users who are not logged in do not hit an error.

= 6.0.5.3 - March 14th, 2016 =

* Removed rogue `return;` causing blank screen on certain pages.
* Wrapped transient in else statement to prevent wrong data from being stored when an error is hit.

= 6.0.5.2 - March 11th, 2016 =

* Added extra error check for empty forms.
* Fixed incorrect 'Invalid Email' response being displayed to the user. (Now more user friendly)
* Fixed some checkbox integrations not working properly.
* Enhanced error logging.

= 6.0.5.1 - March 7th, 2016 =

* Cleaned up an error getting by the check when no interest groups were enabled on a form.
* Ensured 'invalid email' error was being used where appropriate.

= 6.0.5 - March 5th, 2016 =

* Removed the old MailChimp PHP wrapper (increasing stability, and decreasing overall plugin size by 200+kb).
* All API requests are now handled via WP HTTP class (goodbye SSL cert errors)
* Added new `yikes-mailchimp-sslverify` filter to toggle true/false on API requests.
* Added a new 'View List' link below the associated lists on the form edit page.
* Updated all api requests throughout the plugin.
* Re-wrote both the ajax and non-ajax form submission files.
* Re-wrote form validation, error checks and success/error responses.
* More specific error messages now coming from MailChimp for a better debugging experience.
* Repaired broken strings, Optin/optin to Opt-in/opt-in, reCaptcha to reCAPTCHA.
* Fixed user data not properly displaying on the user cards page.

= 6.0.4.7 - March 4th, 2016 =

* Fix error being thrown when the user has not set their name on the profile page.
* Updated the API validation function to use WP HTTP class. (workaround for SSL cert error preventing API key validation)
* Add 'Custom URL' selection to page redirect drop down, allow users to hard code a custom URL to redirect users to (third party site etc.)

= 6.0.4.6 - March 2nd, 2016 =

* Repair 'update existing subscriber' parameter in the API request to respect the options set for the given form (AJAX and non-AJAX forms).

= 6.0.4.5 - March 1st, 2016 =

* Added `load_plugin_textdomain()` call to base class.
* Added missing string to translation.

= 6.0.4.4 - February 29th, 2016 =

* Fixed reCAPTCHA check being skipped when a non-ajax form is submitted.
* Fixed incorrect variable name in reCAPTCHA form submission (non-ajax).
* Re-worded the reCAPTCHA error message when left blank.
* Passed new reCAPTCHA error message through new filter (`yikes-mailchimp-recaptcha-required-error` - works for AJAX and standard forms).
* Added missing placeholder/default values to the date form fields.
* Fixed foreign characters causing issues on certain form fields (all languages should now work without issues).

= 6.0.4.3 - February 23rd, 2016 =

* Added new filter to alter the success message from the form (`yikes-mailchimp-success-response` - see readme.txt for help).
* Added new filter to alter the zip code regex pattern (`yikes-mailchimp-zip-pattern` - see readme.txt for help and default value).
* Added new filter to alter the default country selection in the dropdown. (`yikes-mailchimp-default-country-value` - Defaults to 'US'.)
* Altered zip/state fields, when the default value is set to something other than US via `yikes-mailchimp-default-country-value`.
* Removed `height: 100%` CSS declaration on form fields (causing minor issues on some themes).
* Tweaked front end .js.

= 6.0.4.2 - February 18th, 2016 =

* Add missing .js file to trigger the update existing subscriber detials email on non-ajax forms.
* Re-worded a few strings.

= 6.0.4.1 - February 3rd, 2015 =

* Fixed foreign languages saving field labels with backslashes
* Fixed foreign language dropdown not saving/displaying properly

= 6.0.4 - February 1st, 2015 =

* Added a conditional to upgrade the database if the user is not currently up to date.
* Some users report not being able to update form settings, due to database tables not being present.

= 6.0.3.9 - January 31st, 2015 =

* Refactored date form field submissions, to properly format international dates (dd/mm/yyyy).
* Re-worded sections.
* Added new screenshots.

= 6.0.3.8 - January 29th, 2015 =

* Added a new custom description parameter to the shortcode. eg: `[yikes-mailchimp custom_description="This is a custom description" description="1"]`
* Added all new settings on a per form level. New options now include - Form classes, Inline form, Submit button type, Submit button classes, schedule form by date/time, and require users to be logged in.
* Users can now specify if they want a form to display inline by using the `inline="1"` parameter in the shortcode. Example: `[yikes-mailchimp inline="1"]`. The shortcode parameter will take precedence over the form setting.
* Users can now set the submit button to image, and specify a custom image to use.
* Tweaked styles on the 'Account Activity/Chimp Chatter' page.
* Re-factored a few functions to be more performant.
* Added new, additional hooks for our add-ons to make use of. (`yikes-mailchimp-list-interest-groups-metabox`)
* Fixed the typo in our check box integration filter from `yikes-mailchimp-checkbox-integration-subscibe-api-request` to `yikes-mailchimp-checkbox-integration-subscribe-api-request`.
* Added missing `$charset_collate` variable when creating the database tables - which caused encoding issues with a few foreign characters.
* Localized all date pickers - for our international users.
* Added new sections to the welcome screen - 'Knowledge Base' and 'Add-Ons'.
* Fixed foreign language character encoding, and storing in database as question marks.
* Fixed date formats not storing properly when adding a date/birthday field to your form.
* Fixed the form editor being hidden on medium-width screens.

= 6.0.3.7 - December 28th, 2015 =

* Fixed certain [recaptcha parameters](https://yikesplugins.com/support/knowledge-base/how-do-i-customize-the-recaptcha-field/) not working properly

= 6.0.3.6 - December 28th, 2015 =

* Removed extra closing php tag after 'Interest Group' dropdown field

= 6.0.3.5 - December 20th, 2015 =

* Ensured the `$form_id` variable is set before including the form processing file for non-ajax forms.
* Updated `yikes_retrieve_form_settings()`, to ensure we have a `$form_id` and settings to return.

= 6.0.3.4 - December 18th, 2015 =

* Make bundled classes work when field labels are hidden.
* Way to reset submission counts for individual forms.
* URL fields now prepend http:// to prevent confusion with the end user.
* Added conditionals to hide state/zip input fields in the address section when the country != US.
* Multiple reCAPTCHAs on a single page should now work.
* Non-Ajax Forms set to redirect, throw errors
* Check form descriptions generating additional `<p>` tags.yikes-mailchimp-form-description is not wrapped around the description.
* Add helper function to retrieve form data by ID. (eg: `$form_data = yikes_get_form_data( 1 );` )

= 6.0.3.3 - November 12th, 2015 =

* Patched a minor security issue where post passwords were accessible prior to entering the password - (props @ldwd)

= 6.0.3.2 - November 9th, 2015 =

* International characters in custom messages causing some escaping issues for AJAX forms.
* Added Google ReCaptcha override to the shortcode recaptcha="1"/recpatcha="0" to manually set it on a per form basis (still needs to be globally enabled on the settings page).
* Added additional reCAPTCHA parameters to the shortcode. (see <a href="https://yikesplugins.com/support/knowledge-base/how-do-i-customize-the-recaptcha-field/" tareget="_blank">https://yikesplugins.com/support/knowledge-base/how-do-i-customize-the-recaptcha-field/</a>).
* Re-coded the redirect function for non-ajax forms, so that it properly utilizes `wp_redirect()` instead of a .js injection after submission.
* Added new constant `YIKES_MAILCHIMP_NULL_DEBUG` to debug 'null' API response from MailChimp API (see <a href="https://yikesplugins.com/support/knowledge-base/i-received-the-following-error-we-received-an-unexpected-error-null/" target="_blank">https://yikesplugins.com/support/knowledge-base/i-received-the-following-error-we-received-an-unexpected-error-null/</a>).

= 6.0.3.1 - November 2nd, 2015 =

* Repair issue where multiple AJAX forms on same page was only submitting last displayed form.
* Parsed `[yikes-mailchimp-subscriber-count]`, to display the number of subscribers in the associated list on the manage forms page for form descriptions.
* When 'Hide Label' and 'Hide Field' are both checked, ensure that the associated form field is hidden.
* Confirmed error messages via the MailChimp API are working as intended for both AJAX/standard opt-in forms.
* Fixed issue/spacing of the secondary 'Update Form' button on the edit forms page.

= 6.0.3 - October 29th, 2015 =

* Add filter to allow altering field descriptions. `yikes_mailchimp_frontend_content`
* Resolve error thrown when no default is set for checkbox inerest groups.
* Alter old knowledge base URLs to new KB URL.
* Confirm each form field type 'Hide Field' works as expected.
* Added a bit of spacing between checkbox/radio button default options.
* Added new class `yikes-mailchimp-form-class` to allow for additional classes to be added to the `<form>` element.
* Implemented a fix for required interest group checkbox type. (ajax = js validation/non-ajax = php).
* Appended form IDs to input field ID parameter. The new form IDs now prepended with yikes-mc-form-#- -- eg: Old: id="EMAIL", New: id="yikes-mc-form-1-EMAIL".
* Add a "Save Form" button to the left of the new "Clear Form Fields" on the Form builder. (better UX)
* Integrate with Visual Composer plugin.
* Ability to add a class to the form tag. Appropriate filter is `yikes-mailchimp-form-class` for `<form>` element, and `yikes-mailchimp-form-container-class` for parent `<section>` container.
* Fix Site Origin Page builder issues saving the widget form IDs.

= 6.0.2.4 - October 17th, 2015 =

* Fixed error thrown for some users on edit forms page 'save'.
* Added new shortcode: `[yikes-mailchimp-subscriber-count list="#"]` to display the number of subscribers to a specified list (use: `[yikes-mailchimp-subscriber-count form="form_id"]` (preferred) or `[yikes-mailchimp-subscriber-count list="mc_list_id"]`)
* Added new filter to filter the submit button text (yikes-mailchimp-form-submit-button-text)
* Tweaked international phone number validation - now regex checks [0-9]{1,}
* Added two new classes to field labels - `.merge_tag-label` (eg: EMAIL-label) on all fields & `.yikes-mailchimp-field-required` on fields set to required.
* Added capability check to TinyMCE button in wp editor (defaults to manage_options).
* Tweaked 'show some love' container on the edit forms page.
* Passed form descriptions through `the_content()` to allow for shortcodes to be processed.

= 6.0.2.3 - October 16th, 2015 =

* Fixed incorrect opt-in time being sent to MailChimp for new subscribers (fixed for checkbox integrations, ajax and non-ajax forms)
* Fixed 'Hide Label' displaying twice under interest groups
* Fixed error thrown for custom_fields for some users
* Fixed dropdown interest group data not being sent to MailChimp properly

= 6.0.2.2 - October 15th, 2015 =

* Added the ability to bulk remove form fields from the form builder
* Fixed hidden interest groups from not displaying the default value properly
* Added hidden interest groups to the field type switch
* Fixed interest group errors thrown for some users
* Added new option to replace/update interest groups

= 6.0.2/6.0.2.1 - October 12th, 2015 =

* Added ability to pre-select interest groups for each third party integration (bbpress, contact form 7, buddypress, edd, woocommerce, comment form, registration form).
* Removed "Check your email for the confirmation message." from the default success message if single opt-in is checked.
* Fixed Address field, zip not hiding properly.
* Tweaked class names, labels.
* Renamed clickable pre-defined tags to something more user friendly instead of tags (eg: 'Page Title' instead of {page_title}).
* Renamed the `field-third-left/right` class to `field-third` as it made more sense. Now elements floated left.
* Tweaked pre-defined class styles.
* Altered pre-defined class names for the address fields.
* Built in check for MailChimp class to prevent conflict with other plugins integrating MailChimp.
* Built in responsive styles for pre-defined form class styles (field-half-left/right & field-third).
* Tweak responsive styles on calendar date picker on mobile devices.
* Confirm each integration is working as intended.

= 6.0.1 - October 7th, 2015 =

* This release is a <strong>complete</strong> rewrite of the previous version. Before upgrading to the latest release, it is <em>highly recommended</em> that you take a backup of your database.
* Changed plugin name to Easy Forms for MailChimp to comply with new guidelines for [Plugins that Include Company and/or Product Names in the Plugin Name](https://make.wordpress.org/plugins/2015/10/05/guidelines-for-plugins-that-include-company-andor-product-names-in-the-plugin-name/)
* Enhancements:
* All forms have moved to their own table in the database, yikes_easy_mc_forms.
* Admin interface has been re-designed for a seamless integration into the WordPress dashboard.
* You can now create an unlimited number of forms, and assign them to any of your lists (even multiple forms to the same list).
* Now you can easily duplicate forms at the click of a button.
* We have built out an advanced debugging feature that will log errors as they occur, for easy debugging.
* You can now toggle on/off AJAX form submissions on a per form basis.
* Toggle on or off the MailChimp welcome email being sent.
* You can now quickly switch which list your forms assign subscribers to.
* We now support every type of field you can assign to a form, including interest groups.
* You can now set custom success and error messages, to set messages in your native language.
* Easily browse your lists and view individual subscribers. Manage your subscriptions directly within the plugin.
* We've completely re-designed the settings pages to allow for easier navigation.
* A whole number of additional settings have been enabled for different form input fields.
* Español translated started by @hiwhatsup
* Française translated by @mialevesque
* Português do Brasil translated by @enxaqueca
* reCAPTCHA now loads in the language of the site it's being displayed on.
* All translations functions have been implemented for worldwide i18n.
* We have built out an API and implemented a number of hooks and filters to enable developers to easily extend the plugin [see Knowledge Base](https://yikesplugins.com/support/knowledge-base/product/developer-documentation/?utm_source=wp_plugin_repo&utm_medium=link&utm_campaign=easy_forms_for_mailchimp)
* We have started building out a number of add ons to extend the base functionality of the plugin. [check them out](https://yikesplugins.com/plugins/?utm_source=wp_plugin_repo&utm_medium=link&utm_campaign=easy_forms_for_mailchimp)

= 4.3 - March 17th, 2015 =
* Fixed: Re-import form fields function not properly refreshing the page
* Fixed: Updating a list field no longer throws an empty error

= 5.4.2 - March 10th, 2015 =
* Fixed: custom class names on input fields merged together with other class names making them un-usable.

= 5.4.1 - March 3rd, 2015 =
* Fixed: tinyMCE error thrown when saving settings page, ultimately preventing the ability to store the MailChimp API key.

= 5.4 - March 2nd, 2015 =
* Enhancement: Re-bundled unaltered MailChimp API wrapper class file, and added appropriate class check to prevent conflicts with other MailChimp plugins (Gravity Forms etc.)
* Enhancement: Removed the WYSIWYG editor from the options page. This caused issues for some users who were unable to validate the MailChimp API key.
* Enhancement: Added a new setting to toggle the sending of the MailChimp welcome email. Users can now disable the email all together, on a list by list basis. (checked = disabled)
* Enhancement: Prevented users from being able to update the 'EMAIL' merge variable. Added a notification with instruction on what filter to use.
* Enhancement: Replaced all instances of the old class name (wpyksMCMailChimp API) with the appropriate MailChimp class (Mailchimp)
* Enhancement: Stripped slashes and properly escaped interest group labels


= 5.3.3 - February 26th, 2015 =
* Enhancement: Added a new filter to alter field labels. Very helpful when you want to alter the default 'Email Address' field label to something else. (`yikes_mc_field_label`) (see 'filters' section in 'Other Notes')

= 5.3.2 - February 17th, 2015 =
* Fixed: Patched the error displayed below the opt-in forms when `display_yikes_mc_form_messages` is not defined.

= 5.3.1 - January 13th, 2014 =
* Enhancement: Added new filter to allow users to change which role has access to the administration pages ( `yks-mailchimp-user-role` ) ( check readme for example )

= 5.3 - January 11th, 2014 =
* Enhancement: Added ability to move the success + error messages above or below the form based on a defined constant ( `display_yikes_mc_form_messages` [options: before/after] )
* Enhancement: Added new settings and the ability to show/hide * = required field , from the top of the forms, via the settings page
* Enhancement: Fixed incorrect error 'click here to update your profile' shown on front end on all errors

= 5.2 - December 10th, 2014 =
* New Feature: Added ability to add, edit or delete form fields directly from the WordPress dashboard
* New Feature: Added ability to add, edit or delete interest groups directly from the WordPress dashboard
* New Feature: Add "Update" link to forms when a user has previously subscribed
* New Feature: Added 'default' option to text fields ( with custom pre-defined tags : {post_id} , {post_title} , {page_url} , {blog_name} , {user_logged_in} with the ability to define your own! )
* New Feature: Added the ability to adjust required state, visibility state, merge tag and more
* New Feature: Added the ability to toggle between ssl_verifypeer true/false
* New Feature: Added an error log to help users diagnose errors happening within the plugin (and updated advanced debugging) - found on the debug options of the settings page
* Enhancement: Remove JavaScript dependency to populate place holder values
* Enhancement: Replaced CAPTCHA with the all new reCAPTCHA API from Google
* Enhancement: Introduced all new filters ( check documentation for examples )
* Enhancement: Un-checking 'visibility' now hides the input field (instead of not generating it at all)
* Enhancement: Re-defined YKSEME_PATH for users who have the plugins folder outside of wp-content
* Enhancement: Added new classes to labels and input fields on the front end forms ( new classes yks-mc-label-field-label , yks-mc-form-row-field-label , yks-mc-input-field-row-field-label , yks-mc-input-field-label )
* Bug Fix: Re-sorting fields that had a stored custom class name didn't store properly
* Bug Fix: Wrapped bundled template text in filters
* Bug Fix: Repaired some broken filters (get_form_data_before_send)
* Bug Fix: Fixed labels on 'Manage List Forms' page and added field names to titles
* Bug Fix: Fixed path to check box images on 'Clean Blue' bundled templates
* Bug Fix: Fixed empty MailChimp API key from outputting any string (confused some users)
* Other: Split main class file into multiple included files (help organize the main class file (sub-files located in /lib/inc/)
* Other: Began to build up a [Wiki](https://github.com/yikesinc/yikes-inc-easy-mailchimp-extender/wiki) on Github , for plug in installation/usage instructions
* Other: Altered single/double opt-in strings inside shortcode_form.php ([reference thread](https://wordpress.org/support/topic/code-mangling-on-script-use-in-messageserror-handling))
* Other: Removed 'Interest Group Label' option, as users can now update the name from within the plugin

= 5.1.1 - November 5, 2014 =
Fix: repair 'Opt In' default list drop down on options page
Fix: repair errors being thrown when a commenter is added to a list

= 5.1.0.1 - November 4, 2014 =

Removed the update profile info link, some users brought up security concerns.
Fixed missing argument when using table display formatting.

= 5.1 - November 3, 2014 =

We have added brand new functionality, allowing users to easily customize forms on the fly, through a familiar UI as well as a templating framework to allow users to design and implement their own custom forms. A minor security bug was patched in this release as well. We fixed an issue with the API key check running on each page load, and added a few new filters to allow users to alter text.

= 5.0.9 - October 3rd, 2014 =

**Fixes**

* Added autocomplete="false" to API input field
* Added event listener to form submission (forms can now be placed in modals/slideout menus)

= 5.0.8 - September 23, 2014 =

**Fixes**

* Band-aid fix for the -1 response returned from ajax.php

= 5.0.7 - September 19, 2014 =

**Fixes**

* Security Vulnerability patched - props @g0blinResearch for privately disclosing the issue

= 5.0.6 - August 22, 2014 =

**Fixes**

* fix bug with nonce security check when using table 'Preferred Form Layout' setting

= 5.0.5 - August 21, 2014 =

**Fixes**

- added `stripslashes()` to the following settings fields :
	- Single Opt-in Confirmation Message
	- Double Opt-in Confirmation Message
	- Interest Group Label
	- Opt-in Checkbox Text

**Updates**

- Updated readme FAQ section

= 5.0.4 - August 6, 2014 =
* Update SSL conditional in main plugin file
* Added mcrypt module check, for MailChimp API encryption
* Conditionally loaded scripts and styles in admin ( prevent conflicts )
* Included NONCE security checks on form submissions ( helps prevent CSRF and other attacks )
* Added proper update task function to add missing settings to the options page ( prevents undefined variables for new settings )
* Added missing styles to post page ( added missing icon to tinyMCE button )
* Added missing styles to widget page
* Adjusted Chimp Chatter activity time formatting to return correct time based on user time zone
* New Feature: Real time updates to Account Activity ( utilizing the heartbeat MailChimp API )
* New Feature: Added account activity widget to dashboard ( with live updates using heartbeat MailChimp API )
* Added screenshot of admin dashboard account activity widget

= 4.5 =
* Added reCAPTCHA support to prevent bots and spammers from submitting forms
* Split settings page into three separate sections
* Removed Jetpack sharing icons from appearing in the success messages (removed sharedaddy filter)
* Updated translation files with new strings
* Update existing screen shots and add new screen shot
* Update FAQ
* Added "loaded server modules" to the debug page, to better aid in support requests

= 3.0 =
* Update MailChimp API to v2.0
* Added API Key Validation Check

= 2.2.0 =
* Changed name of plugin to Easy Forms
* Added support for multiples of the same list
* Bug fixes

= 2.1.0 =
* Added support for multiples of the same list
* Bug fixes

= 2.0.0 =
* Supports custom merge vars now
* Allows import from MailChimp
* Allows Table or Div output

=  1.3.1 =
* Fixed form not submitting to MailChimp for anonymous users bug

= 1.3.0 =
* Custom merge vars allows more customized field configuration

= 1.2.0 =
* Removed required from First Name and Last Name fields
* Added update routines for future versions

= 1.1.0 =
* Changed the list logic and added a notice for the MERGE VAR naming schema

= 1.0.1 =
* Changed CSS paths from Absolute to Relative

= 1.0.0 =
* Initial Release
